Index: trunk/LMDZ.MARS/libf/aeronomars/param_read.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/param_read.F	(revision 2579)
+++ trunk/LMDZ.MARS/libf/aeronomars/param_read.F	(revision 2610)
@@ -15,4 +15,6 @@
 
       use datafile_mod, only: datadir
+      use mod_phys_lmdz_para, only : is_master
+      USE mod_phys_lmdz_transfert_para, ONLY: bcast
       
       implicit none
@@ -29,4 +31,6 @@
 
 c     Reads tabulated functions
+
+      if (is_master) then
 
       !Tabulated column amount
@@ -379,4 +383,42 @@
       enddo
 
+      endif ! of if (is_master)
+
+
+      call bcast(c1_16)
+      call bcast(c17_24)
+      call bcast(c25_29)
+      call bcast(c30_31)
+      call bcast(c32)
+      call bcast(c33)
+      call bcast(c34)
+      call bcast(c35)
+      call bcast(c36)
+      call bcast(t0)
+      call bcast(jabsifotsintpar)
+      call bcast(efdisco2)
+      call bcast(efdisco2)
+      call bcast(efdish2o)
+      call bcast(efdish2o2)
+      call bcast(efdish2o2)
+      call bcast(efdish2o2)
+      call bcast(efdisn)
+      call bcast(efdish)
+      call bcast(efdisno)
+      call bcast(efdisn2)
+      call bcast(efdisno2)
+      call bcast(efdisco)
+      call bcast(efionco2)
+      call bcast(efionco2)
+      call bcast(efionco)
+      call bcast(efiono3p)
+      call bcast(efionn)
+      call bcast(efionno)
+      call bcast(efionh)
+      call bcast(fluxtop)
+      call bcast(ct1)
+      call bcast(ct2)
+      call bcast(p1)
+      call bcast(p2)
 
       return
Index: trunk/LMDZ.MARS/libf/aeronomars/param_read_e107.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/param_read_e107.F	(revision 2579)
+++ trunk/LMDZ.MARS/libf/aeronomars/param_read_e107.F	(revision 2610)
@@ -17,4 +17,6 @@
 
       use datafile_mod, only: datadir
+      USE mod_phys_lmdz_para, ONLY: is_master
+      USE mod_phys_lmdz_transfert_para, ONLY: bcast
 
       implicit none
@@ -35,4 +37,5 @@
 c*************************+PROGRAM STARTS**************************
 
+      if(is_master) then
 
 c     Reads tabulated functions
@@ -221,4 +224,5 @@
       enddo
 
+      endif !is master
 
 c     set t0
@@ -232,4 +236,6 @@
          fluxtop(i)=1.
       end do
+
+      if(is_master) then
 
       !Parameters for the variation of the solar flux with 11 years cycle
@@ -284,4 +290,29 @@
       enddo
       close(640)
+
+      endif !is master
+
+      call bcast(t0)
+      call bcast(fluxtop)
+
+      call bcast(c1_16)
+      call bcast(c17_24)
+      call bcast(c25_29)
+      call bcast(c30_31)
+      call bcast(c32)
+      call bcast(c33)
+      call bcast(c34)
+      call bcast(c35)
+      call bcast(c36)
+
+      call bcast(jabsifotsintpar)
+
+      call bcast(coefit0)
+      call bcast(coefit1)
+      call bcast(coefit2)
+      call bcast(coefit3)
+      call bcast(coefit4)
+      call bcast(date_e107)
+      call bcast(e107_tab)
          
 
@@ -376,4 +407,6 @@
          efdish2(inter)=1.
       enddo
+
+      if(is_master) then
          
       !4 possible channels for CO2 ionization
@@ -391,4 +424,12 @@
       enddo
       close(130)
+
+      endif !is_master
+
+      call bcast(i)
+      call bcast(nada)
+      call bcast(efionco2)
+      call bcast(efdisco2)
+
       do inter=17,36
          efdisco2(inter)=1.
@@ -409,5 +450,5 @@
 !      enddo
 
-
+      if(is_master) then
       !2 possible channels for O2 ionization
       open(131,file=trim(datadir)//'/EUVDAT'//
@@ -421,4 +462,12 @@
       enddo
       close(131)
+
+      endif !is_master
+
+      call bcast(i)
+      call bcast(nada)
+      call bcast(efiono2)
+      call bcast(efdiso2)
+
       do inter=24,36
          efdiso2(inter)=1.
@@ -431,4 +480,5 @@
       enddo
 
+      if(is_master) then
 
       !2 channels for N2 ionization
@@ -443,4 +493,12 @@
       enddo
       close(132)
+
+      endif
+
+      call bcast(i)
+      call bcast(nada)
+      call bcast(efionn2)
+      call bcast(efdisn2)
+
       do inter=16,36
          efdisn2(inter)=1.
@@ -454,5 +512,5 @@
 !      enddo
  
-     
+      if(is_master) then     
       !3 channels for CO ionization
        open(133,file=trim(datadir)//'/EUVDAT'//
@@ -468,4 +526,12 @@
       enddo
       close(133)
+
+      endif  !     if(is_master)
+
+      call bcast(i)
+      call bcast(nada)
+      call bcast(efionco)
+      call bcast(efdisco)
+
       do inter=17,36
          efdisco(inter)=1.