Index: /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.fcm
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.fcm	(revision 2619)
+++ /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.fcm	(revision 2619)
@@ -0,0 +1,18 @@
+%COMPILER            mpiifort
+%LINK                mpiifort
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%CPP_FLAGS           -P
+%FPP_DEF             NC_DOUBLE LAPACK BLAS SGEMV=DGEMV SGEMM=DGEMM 
+%BASE_FFLAGS         -real-size 64 -mkl=parallel -fp-model precise -align common -mcmodel=large -shared-intel -heap-arrays 0
+%PROD_FFLAGS         -O2
+%DEV_FFLAGS          -O2 -g -traceback -fpe0
+%DEBUG_FFLAGS        -fpe0 -g -no-ftz -check -traceback -ftrapuv -fp-stack-check -debug
+%C_COMPILER          gcc
+%C_OPTIM             -O3
+%MPI_FFLAGS          
+%OMP_FFLAGS          -openmp
+%BASE_LD             -mkl=parallel
+%MPI_LD               
+%OMP_LD              -openmp
Index: /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.path
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.path	(revision 2619)
+++ /trunk/LMDZ.COMMON/arch/arch-MesoPSLp.path	(revision 2619)
@@ -0,0 +1,19 @@
+ROOT=$PWD
+
+#NETCDF_LIBDIR="-L/usr/local/netcdf-fortran-4.4.intel/lib"
+#NETCDF_INCDIR="-I/usr/local/netcdf-fortran-4.4.intel/include"
+#NETCDF_LIB="-lnetcdff"
+NETCDF_LIBDIR="-L/obs/bcharnay/NETCDF_ifort/lib"
+NETCDF_INCDIR="-I/obs/bcharnay/NETCDF_ifort/include"
+NETCDF_LIB="-lnetcdf -lnetcdff "
+
+
+#IOIPSL_INCDIR="-I/obs/bcharnay/SVN_LMD/LMDZ.COMMON/ioipsl/modipsl/lib"
+#IOIPSL_LIBDIR="-L/obs/bcharnay/SVN_LMD/LMDZ.COMMON/ioipsl/modipsl/lib"
+IOIPSL_INCDIR="-I/obs/bcharnay/LMDG_Yassin/lmdzg-diffussion/LMDZ.COMMON/ioipsl/modipsl/lib"
+IOIPSL_LIBDIR="-L/obs/bcharnay/LMDG_Yassin/lmdzg-diffussion/LMDZ.COMMON/ioipsl/modipsl/lib"
+IOIPSL_LIB="-lioipsl"
+
+XIOS_INCDIR="-I$ROOT/../XIOS/inc"
+XIOS_LIBDIR="-L$ROOT/../XIOS/lib"
+XIOS_LIB="-lxios -lstdc++"
Index: /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.env
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.env	(revision 2619)
+++ /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.env	(revision 2619)
@@ -0,0 +1,1 @@
+export NETCDF_HOME="/obs/bcharnay/NETCDF_ifort"
Index: /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.fcm
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.fcm	(revision 2619)
+++ /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.fcm	(revision 2619)
@@ -0,0 +1,18 @@
+%COMPILER            ifort
+%LINK                ifort
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%CPP_FLAGS           -P
+%FPP_DEF             NC_DOUBLE LAPACK BLAS SGEMV=DGEMV SGEMM=DGEMM
+%BASE_FFLAGS         -real-size 64 -mkl=sequential -fp-model precise -align common -mcmodel=large -shared-intel -heap-arrays 0
+%PROD_FFLAGS         -O2 
+%DEV_FFLAGS          -O2 -g -traceback -fpe0
+%DEBUG_FFLAGS        -fpe0 -g -no-ftz -check -traceback -ftrapuv -fp-stack-check -debug
+%C_COMPILER          gcc
+%C_OPTIM             -O3
+%MPI_FFLAGS
+%OMP_FFLAGS
+%BASE_LD             -mkl=sequential
+%MPI_LD
+%OMP_LD
Index: /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.path
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.path	(revision 2619)
+++ /trunk/LMDZ.COMMON/arch/arch-MesoPSLs.path	(revision 2619)
@@ -0,0 +1,22 @@
+ROOT=$PWD
+
+#NETCDF_LIBDIR="-L/usr/local/netcdf-fortran-4.4.intel/lib"
+#NETCDF_INCDIR="-I/usr/local/netcdf-fortran-4.4.intel/include"
+#NETCDF_LIBDIR="-L/usr/lib/x86_64-linux-gnu/"
+#NETCDF_INCDIR="-I/usr/include/"
+#NETCDF_LIBDIR="-L/shared/apps/netcdf-fortran/4.4.4/intel/18.0.1/lib"
+#NETCDF_INCDIR="-I/shared/apps/netcdf-fortran/4.4.4/intel/18.0.1/include"
+NETCDF_LIBDIR="-L/obs/bcharnay/NETCDF_ifort/lib"
+NETCDF_INCDIR="-I/obs/bcharnay/NETCDF_ifort/include"
+NETCDF_LIB="-lnetcdf -lnetcdff "
+#NETCDF_LIB="-lnetcdf"
+
+IOIPSL_INCDIR="-I/obs/bcharnay/LMD_Gitlab/LMDZ.COMMON/ioipsl/modipsl/lib"
+IOIPSL_LIBDIR="-L/obs/bcharnay/LMD_Gitlab/LMDZ.COMMON/ioipsl/modipsl/lib"
+#IOIPSL_INCDIR="-I/obs/bcharnay/SVN_LMD/LMDZ.COMMON/ioipsl/modipsl/lib"
+#IOIPSL_LIBDIR="-L/obs/bcharnay/SVN_LMD/LMDZ.COMMON/ioipsl/modipsl/lib"
+IOIPSL_LIB="-lioipsl"
+
+XIOS_INCDIR="-I$ROOT/../XIOS/inc"
+XIOS_LIBDIR="-L$ROOT/../XIOS/lib"
+XIOS_LIB="-lxios -lstdc++"