Index: trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 2615)
+++ trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 2636)
@@ -74,4 +74,5 @@
 
 ! 1. identify tracers by their names: (and set corresponding values of mmol)
+! As is done in initracer.F
 
 ! 1.1 initialize tracer indexes to zero:
@@ -82,4 +83,9 @@
       igcm_ccnco2_mass=0
       igcm_ccnco2_number=0
+      igcm_ccnco2_meteor_mass=0
+      igcm_ccnco2_meteor_number=0
+      igcm_ccnco2_h2o_mass_ice=0
+      igcm_ccnco2_h2o_mass_ccn=0
+      igcm_ccnco2_h2o_number=0
       igcm_dust_mass=0
       igcm_dust_number=0
@@ -89,4 +95,10 @@
       igcm_h2o_vap=0
       igcm_h2o_ice=0
+      igcm_hdo_vap=0
+      igcm_hdo_ice=0
+      igcm_stormdust_mass=0
+      igcm_stormdust_number=0
+      igcm_topdust_mass=0
+      igcm_topdust_number=0
       igcm_co2=0
       igcm_co=0
@@ -96,5 +108,10 @@
       igcm_o3=0
       igcm_h=0
+      igcm_d=0
+      igcm_hd=0
       igcm_h2=0
+      igcm_od=0
+      igcm_do2=0
+      igcm_hdo2=0
       igcm_oh=0
       igcm_ho2=0
@@ -109,10 +126,4 @@
       igcm_n2d=0
       igcm_he=0
-      igcm_hdo_vap=0
-      igcm_od=0
-      igcm_d=0
-      igcm_hd=0
-      igcm_do2=0
-      igcm_hdo2=0
       igcm_co2plus=0
       igcm_oplus=0
@@ -160,5 +171,5 @@
       end if ! of if (doubleq)
 
-      if (scavenging) then
+      if (microphys) then
          do iq = 1,nqmx
             if (noms(iq) == "ccn_mass") then
@@ -171,5 +182,5 @@
             end if
          end do
-      end if ! of if (scavenging)
+      end if ! of if (microphys)
 
       if (submicron) then
@@ -183,4 +194,30 @@
       end if ! of if (submicron)
 
+       if (rdstorm) then
+        do iq=1,nq
+          if (noms(iq).eq."stormdust_mass") then
+            igcm_stormdust_mass=iq
+            count=count+1
+          endif
+          if (noms(iq).eq."stormdust_number") then
+            igcm_stormdust_number=iq
+            count=count+1
+          endif
+        enddo
+      endif ! of if (rdstorm)
+
+       if (topflows) then
+        do iq=1,nq
+          if (noms(iq).eq."topdust_mass") then
+            igcm_topdust_mass=iq
+            count=count+1
+          endif
+          if (noms(iq).eq."topdust_number") then
+            igcm_topdust_number=iq
+            count=count+1
+          endif
+        enddo
+      endif ! of if (topflows)    
+
 ! 1.3 find chemistry and water tracers
 
@@ -241,4 +278,9 @@
            count = count + 1
         end if
+        if (noms(iq) == "n2") then
+           igcm_n2 = iq
+           mmol(igcm_n2) = 28.
+           count = count + 1
+        end if
         if (noms(iq) == "ch4") then
            igcm_ch4 = iq
@@ -246,7 +288,7 @@
            count = count + 1
         end if
-        if (noms(iq) == "n2") then
-           igcm_n2 = iq
-           mmol(igcm_n2) = 28.
+        if (noms(iq) == "ar") then
+           igcm_ar = iq
+           mmol(igcm_ar) = 40.
            count = count + 1
         end if
@@ -256,4 +298,14 @@
            count = count + 1
         end if
+        if (noms(iq) == "no") then
+           igcm_no = iq
+           mmol(igcm_no) = 30.
+           count = count + 1
+        end if
+        if (noms(iq) == "no2") then
+           igcm_no2 = iq
+           mmol(igcm_no2) = 46.
+           count = count + 1
+        end if
         if (noms(iq) == "n2d") then
            igcm_n2d = iq
@@ -261,69 +313,96 @@
            count = count + 1
         end if
-        if (noms(iq) == "no") then
-           igcm_no = iq
-           mmol(igcm_no) = 30.
-           count = count + 1
-        end if
-        if (noms(iq) == "no2") then
-           igcm_no2 = iq
-           mmol(igcm_no2) = 46.
-           count = count + 1
-        end if
-        if (noms(iq) == "ar") then
-           igcm_ar = iq
-           mmol(igcm_ar) = 40.
-           count = count + 1
-        end if
-        if (noms(iq) == "h2o_vap") then
-           igcm_h2o_vap = iq
-           mmol(igcm_h2o_vap) = 18.
-           count = count + 1
-        end if
-        if (noms(iq) == "h2o_ice") then
-           igcm_h2o_ice = iq
-           mmol(igcm_h2o_ice) = 18.
-           count = count + 1
-        end if
-        if (noms(iq) == "hdo_vap") then
-           igcm_hdo_vap = iq
-           mmol(igcm_hdo_vap) = 19.
-           count = count + 1
-        end if
-        if (noms(iq) == "hdo_ice") then
-           igcm_hdo_vap = iq
-           mmol(igcm_hdo_ice) = 19.
-           count = count + 1
-        end if
-        if (noms(iq) == "od") then
-           igcm_od = iq
-           mmol(igcm_od) = 18.
-           count = count + 1
-        end if
-        if (noms(iq) == "d") then
-           igcm_d = iq
-           mmol(igcm_d) = 2.
-           count = count + 1
-        end if
-        if (noms(iq) == "hd") then
-           igcm_d = iq
-           mmol(igcm_d) = 3.
-           count = count + 1
-        end if
-        if (noms(iq) == "do2") then
-           igcm_do2 = iq
-           mmol(igcm_do2) = 34.
-           count = count + 1
-        end if
-        if (noms(iq) == "hdo2") then
-           igcm_hdo2 = iq
-           mmol(igcm_hdo2) = 35.
-           count = count + 1
-        end if
-        if (noms(iq).eq."he") then
+        if (noms(iq) == "he") then
           igcm_he=iq
           mmol(igcm_he)=4.
           count=count+1
         endif
+        if (noms(iq) == "h2o_vap") then
+           igcm_h2o_vap = iq
+           mmol(igcm_h2o_vap) = 18.
+           count = count + 1
+        end if
+        if (noms(iq) == "hdo_vap") then
+           igcm_hdo_vap = iq
+           mmol(igcm_hdo_vap) = 19.
+           count = count + 1
+        end if
+        if (noms(iq) == "od") then
+           igcm_od = iq
+           mmol(igcm_od) = 18.
+           count = count + 1
+        end if
+        if (noms(iq) == "d") then
+           igcm_d = iq
+           mmol(igcm_d) = 2.
+           count = count + 1
+        end if
+        if (noms(iq) == "hd") then
+           igcm_d = iq
+           mmol(igcm_d) = 3.
+           count = count + 1
+        end if
+        if (noms(iq) == "do2") then
+           igcm_do2 = iq
+           mmol(igcm_do2) = 34.
+           count = count + 1
+        end if
+        if (noms(iq) == "hdo2") then
+           igcm_hdo2 = iq
+           mmol(igcm_hdo2) = 35.
+           count = count + 1
+        end if
+
+! aerosols
+        if (noms(iq) == "co2_ice") then
+          igcm_co2_ice=iq
+          mmol(igcm_co2_ice)=44.
+          count=count+1
+        endif
+        if (noms(iq) == "h2o_ice") then
+           igcm_h2o_ice = iq
+           mmol(igcm_h2o_ice) = 18.
+           count = count + 1
+        end if
+        if (noms(iq) == "hdo_ice") then
+           igcm_hdo_ice = iq
+           mmol(igcm_hdo_ice) = 19.
+           count = count + 1
+        end if
+
+        if (co2clouds) then
+           if (noms(iq).eq."ccnco2_mass") then
+              igcm_ccnco2_mass=iq
+              count=count+1
+           endif
+           if (noms(iq).eq."ccnco2_number") then
+              igcm_ccnco2_number=iq
+              count=count+1
+           endif
+           if (meteo_flux) then
+             if (noms(iq).eq."ccnco2_meteor_mass") then
+                igcm_ccnco2_meteor_mass=iq
+                count=count+1
+             endif
+             if (noms(iq).eq."ccnco2_meteor_number") then
+                igcm_ccnco2_meteor_number=iq
+                count=count+1
+             endif
+           end if
+           if (co2useh2o) then
+           if (noms(iq).eq."ccnco2_h2o_number") then
+              igcm_ccnco2_h2o_number=iq
+              count=count+1
+           endif
+           if (noms(iq).eq."ccnco2_h2o_mass_ice") then
+              igcm_ccnco2_h2o_mass_ice=iq
+              count=count+1
+           endif
+           if (noms(iq).eq."ccnco2_h2o_mass_ccn") then
+              igcm_ccnco2_h2o_mass_ccn=iq
+              count=count+1
+           endif
+           end if
+        endif ! of if (co2clouds)
 
 ! 1.4 find ions